program remake_ord

    integer:: N_max, R_max
    real, dimension(:), allocatable :: y
    real, dimension(:,:), allocatable :: x 
    integer, dimension(:,:), allocatable :: xi
    character*1 iord
    character*50 in_file, out_file, remesh_file, type
    integer:: p_max, dof_tot, ncount, dof_min, dof_max, dof_old, i_remesh
    real :: Eip_aver, Eip_max, tau_aver, EL8L2, intEL2L2, intEL8L2, EintEL2L2, EintEL8L2 
    real :: e1, e2, e3, a1, a2, a3, a0, hx
    integer :: dof, it, iter_tot
    integer:: i, ires, ires1, ires2, imesh, il, k, itab, Miter, itab1
    logical :: iprint, adapt

    itab = 13
    open(itab, file='tab.tex',status='UNKNOWN', position='append')

    itab1 = 14


    if (command_argument_count() == 3) then
       call get_command_argument(1,in_file)
       
       call get_command_argument(2,out_file)

       call get_command_argument(3,type)

       !call get_command_argument(4,iord)

       !if(iord == "1") then
       !   open(itab1, file='data.dat',status='OLD')
       !   read(itab1, *) e1, e2, e3, dof, it
       !   close(itab1)
       !endif


    else
       print*,'% Syntax:  re_order_dat  <input order.dat> <output orde.dat>' 
       ! <remesh.dat>'
       print*, 'or'
       print*,'% Syntax:  re_order_dat  tab_init/ hline / tab_end '
       stop
    endif

    ires = 11
    open(ires, file=in_file,status='OLD')

    ires1 = 12
    if(type == "beamer" .or. type == "beamerE" ) then
       open(ires1, file=out_file,status='UNKNOWN', position = "append")
    else
       open(ires1, file=out_file,status='UNKNOWN')
    endif
!    ires2 = 21
!    open(ires2, file=remesh_file,status='UNKNOWN')

    
    N_max = 50000
    R_max = 100

    allocate(x(1:N_max, 1:R_max), xi(1:N_max, 1:R_max), y(1:R_max) ) 
    
    ! reading of data
    do k = 1,N_max
       read(ires, *, end=110) xi(k,1), x(k,2:3), xi(k,4:6), x(k,7), xi(k,8:9), x(k,10:80), &
            xi(k,81:82), x(k,82:85),xi(k, 87:89), x(k, 90)
    enddo
110 imesh = k-1

    adapt = .true.
    if(xi(1,9) == 0) adapt= .false.

    if(type == 'exp' ) then
       !write(ires1,*) '{\scriptsize'
       write(ires1,*) '{\small'
       write(ires1,*) '  \setlength{\tabcolsep}{2pt}'
       write(ires1,*) '\begin{tabular}{|ccccc|cccccc|ccc|ccc|ccc|}'
       write(ires1,*) '\hline'
       
       write(ires1, *) " $p$ & $q$ &"
       if(.not. adapt) write(ires1, *) " $ N $ &  "
       if( adapt) write(ires1, *) " $\omega$ &  "
       write(ires1, *) " $DoF$  &"
       write(ires1, *) " $\#\tau_m $  &"
       write(ires1, *) "$ \|e_h\|_{L^\infty(L^2)} $ & $ \|e_h\|_{L^2(L^2)} $  & " 
       write(ires1, *) "$ \|e_h\|_{L^2(H^1)} $ & $ \|[u_h]\|_{L^2(L^2)} $  & " 
       write(ires1, *) "aver $ \|\{u_h\} \|_{L^2} $ & "
       write(ires1, *) "max $ \|\{u_h\} \|_{L^2} $ & "
       write(ires1, *) "$ \|w_h^R\|_{L^\infty(L^2)} $ & $ \|w_h^R\|_{L^2(L^2)} $  & " 
       write(ires1, *) "$ \|w_h^R\|_{L^2(H^1)} $ &"
       write(ires1, *) "$ \|w_h^E\|_{L^2} $ & $ \|w_h^E\|_{L^\infty} $  & " 
       write(ires1, *) "$ \|w_h^E\|_{H^1} $ &"
       write(ires1, *) "$ i_N$ & $ i_L $ & CPU \\ " 
       write(ires1,*) '\hline'

    elseif(type == 'beamerB' ) then
       write(ires1,*) '{\scriptsize'
       write(ires1,*) '  \setlength{\tabcolsep}{4pt}'
       write(ires1,*) '\begin{tabular}{|c|r|cc|cc|}'
       write(ires1,*) '\hline'
       
       !write(ires1, *) " $p$ & $q$ &"
       !if(.not. adapt) write(ires1, *) " $ N $ &  "
       !if( adapt) write(ires1, *) " $\omega$ &  "
       write(ires1, *) " & $DoF$ \  &"
       write(ires1, *) "$ \|e_h\|_{L^\infty(L^2)} $ &" ! $ \|e_h\|_{L^2(L^2)} $  & " 
       write(ires1, *) "$ \|w_h^R\|_{L^\infty(L^2)} $ & " ! $ \|w_h^R\|_{L^2(L^2)} $  & " 
       !write(ires1, *) "$ i_N$ & $ i_L $ & CPU \\ " 
       write(ires1, *) "aver $ \|\{u_h\} \|_{L^2} $ & "
       write(ires1, *) "max $ \|\{u_h\} \|_{L^2} $ \\ "
       !write(ires1, *) "max $ \|\{u_h\} \|_{L^2} $ & "
       !write(ires1, *) "CPU \\ " 
       write(ires1,*) '\hline'

       
    endif
    
    dof = 0
    iter = 0
    do k=1, imesh
       !!!!x(k,39) = x(k,39)/ xi(k,8)
       !!!!x(k,40) = x(k,40)/ xi(k,8)
       if(xi(k,9) == 0 ) then
          iter_tot = xi(k,8)
       else
          iter_tot = xi(k,9)
       endif
       x(k,39) = x(k,39)/iter_tot
       
       !write(*, 245) xi(k,5), x(k,2:3), x(k,31),x(k,32),x(k,34),x(k,36), iter_tot,x(k,39:40)
       if(type == 'exp' ) then
          if(adapt) then
             write(ires1,99) xi(k,5:6), x(k,79)   ! tolerance
          else
             write(ires1,98) xi(k,5:6), xi(k,1)   ! nelem
          endif
          write(ires1,'(a6, i8)') '& ', xi(k,4)   ! DOF
          write(ires1,'(a6, i8)') '& ', iter_tot   ! number of time step
          
          write(ires1,101) x(k,31),x(k,32),x(k,34),x(k,36), &
               x(k,39:40), x(k,55:57),  x(k,52:54), xi(k,87), xi(k,89),x(k,71)
          if(k > 1) then
             do i=31,57
                y(i) = log(x(k,i) / x(k-1,i)) / log( sqrt( 1.*xi(k-1,4)/ xi(k,4)) )
             enddo
             write(ires1,201)  y(31),y(32),y(34),y(36),y(39:40),y(55:57),y(52:54)
          endif

       elseif(type == 'beamer' .or. type == 'beamerB' .or. type == 'beamerE' ) then
          if(k == 1) then
             if(adapt) then
                write(ires1,*) ' \Al{$ hp $ adapt } & '
             else
                write(ires1,'(a8,i1,a15)') ' \Al{$ P_',xi(k,5),' $ fixed} & '
             endif
          else
             write(ires1,*) ' & '
          endif
             
          write(ires1, *)  '  \Alp{', xi(k,4),'}'   ! DOF
          write(ires1,151) x(k,31), & !x(k,32),
               x(k,55), x(k,39:40) !, x(k,71)
 
          
       endif
       
       
       iter = iter + 1
       dof = dof + xi(k,4)
       
    enddo
    if(type /= 'beamer' .and.  type /= 'beamerB' ) then
       write(ires1,*) '\hline'
       write(ires1,*) '\end{tabular}'
       write(ires1,*) '}'
    else
       write(ires1,*) '\hline'
       write(ires1,*) '\hline'
       
    endif
    
245 format( i6,6es12.4,i6,30es12.4 )

98 format( 2(i6, '&'), i12 )
99 format( 2(i6, '&'), es10.2 )
101 format( 12('  &  ', es12.3), 2(' & ', i8), '&', f8.1 '\\' )

201 format( ' & & & &', 12('  & {\scriptsize ', f6.2 ,'}  '), ' & & & \\' )

150 format( 4('  &  ', es12.3), '&', f8.1 '\\' )
151 format(  '&  \Alpp{', es12.3,'} & \Alppp{', es12.3,'} & \Alpppp{' , es12.3,'} & \Alpppp{', es12.3 , '} \\ '  ) !!!!!&', f8.1 '\\' )


    k = imesh
    
    close(ires)
    close(ires1)
      
      
  end program remake_ord
